<?php

namespace Sabre\BargainFinderMax;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AdvResTicketingType' => '\\Sabre\\BargainFinderMax\\Structs\\AdvResTicketingType',
            'AdvReservation' => '\\Sabre\\BargainFinderMax\\Structs\\AdvReservation',
            'AdvTicketing' => '\\Sabre\\BargainFinderMax\\Structs\\AdvTicketing',
            'CompanyNameType' => '\\Sabre\\BargainFinderMax\\Structs\\CompanyNameType',
            'EquipmentType' => '\\Sabre\\BargainFinderMax\\Structs\\EquipmentType',
            'VoluntaryChangesSMPType' => '\\Sabre\\BargainFinderMax\\Structs\\VoluntaryChangesSMPType',
            'Penalty' => '\\Sabre\\BargainFinderMax\\Structs\\Penalty',
            'PassengerTypeQuantityType' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerTypeQuantityType',
            'TPA_Extensions' => '\\Sabre\\BargainFinderMax\\Structs\\TPA_Extensions',
            'BirthDate' => '\\Sabre\\BargainFinderMax\\Structs\\BirthDate',
            'Age' => '\\Sabre\\BargainFinderMax\\Structs\\Age',
            'State' => '\\Sabre\\BargainFinderMax\\Structs\\State',
            'TotalNumber' => '\\Sabre\\BargainFinderMax\\Structs\\TotalNumber',
            'StayRestrictionsType' => '\\Sabre\\BargainFinderMax\\Structs\\StayRestrictionsType',
            'MinimumStay' => '\\Sabre\\BargainFinderMax\\Structs\\MinimumStay',
            'MaximumStay' => '\\Sabre\\BargainFinderMax\\Structs\\MaximumStay',
            'TravelerCountType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerCountType',
            'VoluntaryChangesType' => '\\Sabre\\BargainFinderMax\\Structs\\VoluntaryChangesType',
            'OTA_AirLowFareSearchRQ' => '\\Sabre\\BargainFinderMax\\Structs\\OTA_AirLowFareSearchRQ',
            'OriginDestinationInformation' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationInformation',
            'Baggage' => '\\Sabre\\BargainFinderMax\\Structs\\Baggage',
            'Leg' => '\\Sabre\\BargainFinderMax\\Structs\\Leg',
            'DepartureDateTime' => '\\Sabre\\BargainFinderMax\\Structs\\DepartureDateTime',
            'Origins' => '\\Sabre\\BargainFinderMax\\Structs\\Origins',
            'Origin' => '\\Sabre\\BargainFinderMax\\Structs\\Origin',
            'Carriers' => '\\Sabre\\BargainFinderMax\\Structs\\Carriers',
            'ExcludeVendorPref' => '\\Sabre\\BargainFinderMax\\Structs\\ExcludeVendorPref',
            'Destinations' => '\\Sabre\\BargainFinderMax\\Structs\\Destinations',
            'Destination' => '\\Sabre\\BargainFinderMax\\Structs\\Destination',
            'Cabin' => '\\Sabre\\BargainFinderMax\\Structs\\Cabin',
            'MessagingDetails' => '\\Sabre\\BargainFinderMax\\Structs\\MessagingDetails',
            'MDRSubset' => '\\Sabre\\BargainFinderMax\\Structs\\MDRSubset',
            'AlternateAirportCities' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateAirportCities',
            'SpecifiedLocation' => '\\Sabre\\BargainFinderMax\\Structs\\SpecifiedLocation',
            'AlternateLocation' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateLocation',
            'AlternateAirportMileage' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateAirportMileage',
            'SplitTaxes' => '\\Sabre\\BargainFinderMax\\Structs\\SplitTaxes',
            'AlternateDatesProcessing' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateDatesProcessing',
            'ItineraryCache' => '\\Sabre\\BargainFinderMax\\Structs\\ItineraryCache',
            'MultiTicket' => '\\Sabre\\BargainFinderMax\\Structs\\MultiTicket',
            'Partitions' => '\\Sabre\\BargainFinderMax\\Structs\\Partitions',
            'ReservationData' => '\\Sabre\\BargainFinderMax\\Structs\\ReservationData',
            'AirTravelerType' => '\\Sabre\\BargainFinderMax\\Structs\\AirTravelerType',
            'ProfileRef' => '\\Sabre\\BargainFinderMax\\Structs\\ProfileRef',
            'FlightSegmentRPHs' => '\\Sabre\\BargainFinderMax\\Structs\\FlightSegmentRPHs',
            'BookingClassPrefType' => '\\Sabre\\BargainFinderMax\\Structs\\BookingClassPrefType',
            'PriceRequestInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\PriceRequestInformationType',
            'NegotiatedFareCode' => '\\Sabre\\BargainFinderMax\\Structs\\NegotiatedFareCode',
            'AccountCode' => '\\Sabre\\BargainFinderMax\\Structs\\AccountCode',
            'PublicFare' => '\\Sabre\\BargainFinderMax\\Structs\\PublicFare',
            'PrivateFare' => '\\Sabre\\BargainFinderMax\\Structs\\PrivateFare',
            'IATAFare' => '\\Sabre\\BargainFinderMax\\Structs\\IATAFare',
            'WebFare' => '\\Sabre\\BargainFinderMax\\Structs\\WebFare',
            'Priority' => '\\Sabre\\BargainFinderMax\\Structs\\Priority',
            'Price' => '\\Sabre\\BargainFinderMax\\Structs\\Price',
            'DirectFlights' => '\\Sabre\\BargainFinderMax\\Structs\\DirectFlights',
            'Time' => '\\Sabre\\BargainFinderMax\\Structs\\Time',
            'Vendor' => '\\Sabre\\BargainFinderMax\\Structs\\Vendor',
            'MarketingCarrier' => '\\Sabre\\BargainFinderMax\\Structs\\MarketingCarrier',
            'Carrier' => '\\Sabre\\BargainFinderMax\\Structs\\Carrier',
            'OperatingCarrier' => '\\Sabre\\BargainFinderMax\\Structs\\OperatingCarrier',
            'ElapsedTime' => '\\Sabre\\BargainFinderMax\\Structs\\ElapsedTime',
            'DepartureTime' => '\\Sabre\\BargainFinderMax\\Structs\\DepartureTime',
            'ConnectionTime' => '\\Sabre\\BargainFinderMax\\Structs\\ConnectionTime',
            'Indicators' => '\\Sabre\\BargainFinderMax\\Structs\\Indicators',
            'RetainFare' => '\\Sabre\\BargainFinderMax\\Structs\\RetainFare',
            'MinMaxStay' => '\\Sabre\\BargainFinderMax\\Structs\\MinMaxStay',
            'RefundPenalty' => '\\Sabre\\BargainFinderMax\\Structs\\RefundPenalty',
            'ResTicketing' => '\\Sabre\\BargainFinderMax\\Structs\\ResTicketing',
            'TravelPolicy' => '\\Sabre\\BargainFinderMax\\Structs\\TravelPolicy',
            'CustomerType' => '\\Sabre\\BargainFinderMax\\Structs\\CustomerType',
            'MultipleTravelerGroups' => '\\Sabre\\BargainFinderMax\\Structs\\MultipleTravelerGroups',
            'BrandedFareIndicators' => '\\Sabre\\BargainFinderMax\\Structs\\BrandedFareIndicators',
            'ReturnCheapestUnbrandedFare' => '\\Sabre\\BargainFinderMax\\Structs\\ReturnCheapestUnbrandedFare',
            'PassengerStatus' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerStatus',
            'ETicketableOverride' => '\\Sabre\\BargainFinderMax\\Structs\\ETicketableOverride',
            'Currency' => '\\Sabre\\BargainFinderMax\\Structs\\Currency',
            'UseReducedConstructions' => '\\Sabre\\BargainFinderMax\\Structs\\UseReducedConstructions',
            'OBFees' => '\\Sabre\\BargainFinderMax\\Structs\\OBFees',
            'FareBreaksAtLegs' => '\\Sabre\\BargainFinderMax\\Structs\\FareBreaksAtLegs',
            'FareAdjustment' => '\\Sabre\\BargainFinderMax\\Structs\\FareAdjustment',
            'ForceCompanion' => '\\Sabre\\BargainFinderMax\\Structs\\ForceCompanion',
            'UsePassengerFares' => '\\Sabre\\BargainFinderMax\\Structs\\UsePassengerFares',
            'UseNegotiatedFares' => '\\Sabre\\BargainFinderMax\\Structs\\UseNegotiatedFares',
            'TravelerInfoSummaryType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerInfoSummaryType',
            'TravelerInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerInformationType',
            'TravelerInfoSummary_TPA_ExtensionsType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerInfoSummary_TPA_ExtensionsType',
            'TravelerRating' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerRating',
            'Score' => '\\Sabre\\BargainFinderMax\\Structs\\Score',
            'FrequentFlyer' => '\\Sabre\\BargainFinderMax\\Structs\\FrequentFlyer',
            'TravelerRefNumberType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelerRefNumberType',
            'AirSearchPrefsType' => '\\Sabre\\BargainFinderMax\\Structs\\AirSearchPrefsType',
            'FareRestrictPref' => '\\Sabre\\BargainFinderMax\\Structs\\FareRestrictPref',
            'NumTripsWithRouting' => '\\Sabre\\BargainFinderMax\\Structs\\NumTripsWithRouting',
            'TripType' => '\\Sabre\\BargainFinderMax\\Structs\\TripType',
            'MaxPrice' => '\\Sabre\\BargainFinderMax\\Structs\\MaxPrice',
            'ContentType' => '\\Sabre\\BargainFinderMax\\Structs\\ContentType',
            'DomesticLayoverTime' => '\\Sabre\\BargainFinderMax\\Structs\\DomesticLayoverTime',
            'LongConnectTime' => '\\Sabre\\BargainFinderMax\\Structs\\LongConnectTime',
            'LongConnectPoints' => '\\Sabre\\BargainFinderMax\\Structs\\LongConnectPoints',
            'AirServiceOnly' => '\\Sabre\\BargainFinderMax\\Structs\\AirServiceOnly',
            'JetServiceOnly' => '\\Sabre\\BargainFinderMax\\Structs\\JetServiceOnly',
            'SameConnectionAirportOnly' => '\\Sabre\\BargainFinderMax\\Structs\\SameConnectionAirportOnly',
            'SameOriginAirportOnly' => '\\Sabre\\BargainFinderMax\\Structs\\SameOriginAirportOnly',
            'SameTurnaroundAirportOnly' => '\\Sabre\\BargainFinderMax\\Structs\\SameTurnaroundAirportOnly',
            'AircraftTypePenalty' => '\\Sabre\\BargainFinderMax\\Structs\\AircraftTypePenalty',
            'AlternateAirportPenalty' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateAirportPenalty',
            'FareAmountThreshold' => '\\Sabre\\BargainFinderMax\\Structs\\FareAmountThreshold',
            'numOfLowFareSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfLowFareSol',
            'numOfMustPriceOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceOnlSol',
            'numOfMustPriceInrlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceInrlSol',
            'numOfMustPriceNStpOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceNStpOnlSol',
            'numOfMustPriceNStpInrlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceNStpInrlSol',
            'numOfMustPriceSStopOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceSStopOnlSol',
            'stpPenaltyInUSD' => '\\Sabre\\BargainFinderMax\\Structs\\StpPenaltyInUSD',
            'durPenaltyInUSD' => '\\Sabre\\BargainFinderMax\\Structs\\DurPenaltyInUSD',
            'depPenaltyInUSD' => '\\Sabre\\BargainFinderMax\\Structs\\DepPenaltyInUSD',
            'maxAllowedMustPriceOveragePerCrr' => '\\Sabre\\BargainFinderMax\\Structs\\MaxAllowedMustPriceOveragePerCrr',
            'fltOptMustPriceReuseLimit' => '\\Sabre\\BargainFinderMax\\Structs\\FltOptMustPriceReuseLimit',
            'upperBoundMustPriceFactorForNotNonStp' => '\\Sabre\\BargainFinderMax\\Structs\\UpperBoundMustPriceFactorForNotNonStp',
            'upperBoundLFSFactor' => '\\Sabre\\BargainFinderMax\\Structs\\UpperBoundLFSFactor',
            'numOfMustPriceNStp1StpOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceNStp1StpOnlSol',
            'numOfMustPriceNStp1StpInrlSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPriceNStp1StpInrlSol',
            'upperBoundMustPriceFactorForNonStp' => '\\Sabre\\BargainFinderMax\\Structs\\UpperBoundMustPriceFactorForNonStp',
            'maxAllowedLFSOveragePerCrrPercent' => '\\Sabre\\BargainFinderMax\\Structs\\MaxAllowedLFSOveragePerCrrPercent',
            'targetMinNumOfLFSOnlSolPerCrr' => '\\Sabre\\BargainFinderMax\\Structs\\TargetMinNumOfLFSOnlSolPerCrr',
            'targetMinNumOfLFSTotOnlSolPercent' => '\\Sabre\\BargainFinderMax\\Structs\\TargetMinNumOfLFSTotOnlSolPercent',
            'fltOptLFSReuseLimitForNonAVS' => '\\Sabre\\BargainFinderMax\\Structs\\FltOptLFSReuseLimitForNonAVS',
            'fltOptLFSReuseLimitForAVS' => '\\Sabre\\BargainFinderMax\\Structs\\FltOptLFSReuseLimitForAVS',
            'avsPenaltyCrrs' => '\\Sabre\\BargainFinderMax\\Structs\\AvsPenaltyCrrs',
            'maxNumOfNonStpOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\MaxNumOfNonStpOnlSol',
            'maxNumOfNonStpInrlSol' => '\\Sabre\\BargainFinderMax\\Structs\\MaxNumOfNonStpInrlSol',
            'maxNumOfSingleStpOnlSol' => '\\Sabre\\BargainFinderMax\\Structs\\MaxNumOfSingleStpOnlSol',
            'maxNumOf2PlusStpSol' => '\\Sabre\\BargainFinderMax\\Structs\\MaxNumOf2PlusStpSol',
            'minAllowedOveragePerCrrPercent' => '\\Sabre\\BargainFinderMax\\Structs\\MinAllowedOveragePerCrrPercent',
            'minAllowedOveragePerCrr' => '\\Sabre\\BargainFinderMax\\Structs\\MinAllowedOveragePerCrr',
            'maxRelFareLvlOfxForNonStp' => '\\Sabre\\BargainFinderMax\\Structs\\MaxRelFareLvlOfxForNonStp',
            'maxRelFareLvlOfxForCnx' => '\\Sabre\\BargainFinderMax\\Structs\\MaxRelFareLvlOfxForCnx',
            'numOfMustPrice2PlusStpSol' => '\\Sabre\\BargainFinderMax\\Structs\\NumOfMustPrice2PlusStpSol',
            'ItineraryNumberThreshold' => '\\Sabre\\BargainFinderMax\\Structs\\ItineraryNumberThreshold',
            'TicketingSumOfLocals' => '\\Sabre\\BargainFinderMax\\Structs\\TicketingSumOfLocals',
            'MultiAirportCodes' => '\\Sabre\\BargainFinderMax\\Structs\\MultiAirportCodes',
            'ExcludeCallDirectCarriers' => '\\Sabre\\BargainFinderMax\\Structs\\ExcludeCallDirectCarriers',
            'ValidatingCarrierCheck' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrierCheck',
            'SettlementValidation' => '\\Sabre\\BargainFinderMax\\Structs\\SettlementValidation',
            'IETValidation' => '\\Sabre\\BargainFinderMax\\Structs\\IETValidation',
            'Country' => '\\Sabre\\BargainFinderMax\\Structs\\Country',
            'FlightRepeatLimit' => '\\Sabre\\BargainFinderMax\\Structs\\FlightRepeatLimit',
            'DiversityParameters' => '\\Sabre\\BargainFinderMax\\Structs\\DiversityParameters',
            'Weightings' => '\\Sabre\\BargainFinderMax\\Structs\\Weightings',
            'TimeOfDayDistribution' => '\\Sabre\\BargainFinderMax\\Structs\\TimeOfDayDistribution',
            'TimeOfDayRange' => '\\Sabre\\BargainFinderMax\\Structs\\TimeOfDayRange',
            'AdditionalFareLimit' => '\\Sabre\\BargainFinderMax\\Structs\\AdditionalFareLimit',
            'FareFocusRules' => '\\Sabre\\BargainFinderMax\\Structs\\FareFocusRules',
            'SellingLevels' => '\\Sabre\\BargainFinderMax\\Structs\\SellingLevels',
            'SellingLevelRules' => '\\Sabre\\BargainFinderMax\\Structs\\SellingLevelRules',
            'ShowFareAmounts' => '\\Sabre\\BargainFinderMax\\Structs\\ShowFareAmounts',
            'Budget' => '\\Sabre\\BargainFinderMax\\Structs\\Budget',
            'OptionsPerDatePairList' => '\\Sabre\\BargainFinderMax\\Structs\\OptionsPerDatePairList',
            'CountryPref' => '\\Sabre\\BargainFinderMax\\Structs\\CountryPref',
            'ForceKeywordRestrictedContent' => '\\Sabre\\BargainFinderMax\\Structs\\ForceKeywordRestrictedContent',
            'FlightRestrictions' => '\\Sabre\\BargainFinderMax\\Structs\\FlightRestrictions',
            'LowCostCarriersProcessing' => '\\Sabre\\BargainFinderMax\\Structs\\LowCostCarriersProcessing',
            'AncillaryFees' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFees',
            'AncillaryFeeGroup' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeGroup',
            'CommissionCodeQualifiers' => '\\Sabre\\BargainFinderMax\\Structs\\CommissionCodeQualifiers',
            'CommissionCodeQualifier' => '\\Sabre\\BargainFinderMax\\Structs\\CommissionCodeQualifier',
            'CabinPrefType' => '\\Sabre\\BargainFinderMax\\Structs\\CabinPrefType',
            'EquipmentTypePref' => '\\Sabre\\BargainFinderMax\\Structs\\EquipmentTypePref',
            'FareRestrictPrefType' => '\\Sabre\\BargainFinderMax\\Structs\\FareRestrictPrefType',
            'FlightTypePrefType' => '\\Sabre\\BargainFinderMax\\Structs\\FlightTypePrefType',
            'VendorPrefApplicabilityType' => '\\Sabre\\BargainFinderMax\\Structs\\VendorPrefApplicabilityType',
            'CompanyNamePrefType' => '\\Sabre\\BargainFinderMax\\Structs\\CompanyNamePrefType',
            'TicketDistribPrefType' => '\\Sabre\\BargainFinderMax\\Structs\\TicketDistribPrefType',
            'AddressType' => '\\Sabre\\BargainFinderMax\\Structs\\AddressType',
            'BookingChannelType' => '\\Sabre\\BargainFinderMax\\Structs\\BookingChannelType',
            'ConnectionType' => '\\Sabre\\BargainFinderMax\\Structs\\ConnectionType',
            'ConnectionLocation' => '\\Sabre\\BargainFinderMax\\Structs\\ConnectionLocation',
            'CountryNameType' => '\\Sabre\\BargainFinderMax\\Structs\\CountryNameType',
            'CustLoyaltyType' => '\\Sabre\\BargainFinderMax\\Structs\\CustLoyaltyType',
            'DocumentType' => '\\Sabre\\BargainFinderMax\\Structs\\DocumentType',
            'EmailType' => '\\Sabre\\BargainFinderMax\\Structs\\EmailType',
            'RequestLocationType' => '\\Sabre\\BargainFinderMax\\Structs\\RequestLocationType',
            'RequestSpecifiedLocationType' => '\\Sabre\\BargainFinderMax\\Structs\\RequestSpecifiedLocationType',
            'OriginDestinationInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationInformationType',
            'OriginLocation' => '\\Sabre\\BargainFinderMax\\Structs\\OriginLocation',
            'DestinationLocation' => '\\Sabre\\BargainFinderMax\\Structs\\DestinationLocation',
            'POS_Type' => '\\Sabre\\BargainFinderMax\\Structs\\POS_Type',
            'PersonNameType' => '\\Sabre\\BargainFinderMax\\Structs\\PersonNameType',
            'PositionType' => '\\Sabre\\BargainFinderMax\\Structs\\PositionType',
            'SourceType' => '\\Sabre\\BargainFinderMax\\Structs\\SourceType',
            'StateProvType' => '\\Sabre\\BargainFinderMax\\Structs\\StateProvType',
            'StreetNmbrType' => '\\Sabre\\BargainFinderMax\\Structs\\StreetNmbrType',
            'TelephoneType' => '\\Sabre\\BargainFinderMax\\Structs\\TelephoneType',
            'OverrideDateTimeType' => '\\Sabre\\BargainFinderMax\\Structs\\OverrideDateTimeType',
            'GlobalDateTimeType' => '\\Sabre\\BargainFinderMax\\Structs\\GlobalDateTimeType',
            'DateTimeType' => '\\Sabre\\BargainFinderMax\\Structs\\DateTimeType',
            'TravelDateTimeType' => '\\Sabre\\BargainFinderMax\\Structs\\TravelDateTimeType',
            'DepartureDates' => '\\Sabre\\BargainFinderMax\\Structs\\DepartureDates',
            'LengthOfStay' => '\\Sabre\\BargainFinderMax\\Structs\\LengthOfStay',
            'LengthOfStayRange' => '\\Sabre\\BargainFinderMax\\Structs\\LengthOfStayRange',
            'ArrivalDates' => '\\Sabre\\BargainFinderMax\\Structs\\ArrivalDates',
            'UniqueID_Type' => '\\Sabre\\BargainFinderMax\\Structs\\UniqueID_Type',
            'TaxCodeType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxCodeType',
            'TaxCodeAmountType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxCodeAmountType',
            'TransactionType' => '\\Sabre\\BargainFinderMax\\Structs\\TransactionType',
            'ServiceTag' => '\\Sabre\\BargainFinderMax\\Structs\\ServiceTag',
            'CustomerProfile' => '\\Sabre\\BargainFinderMax\\Structs\\CustomerProfile',
            'PurchaseType' => '\\Sabre\\BargainFinderMax\\Structs\\PurchaseType',
            'SabreAth' => '\\Sabre\\BargainFinderMax\\Structs\\SabreAth',
            'TranID' => '\\Sabre\\BargainFinderMax\\Structs\\TranID',
            'ClientSessionID' => '\\Sabre\\BargainFinderMax\\Structs\\ClientSessionID',
            'Branch' => '\\Sabre\\BargainFinderMax\\Structs\\Branch',
            'CompressResponse' => '\\Sabre\\BargainFinderMax\\Structs\\CompressResponse',
            'FareOverrides' => '\\Sabre\\BargainFinderMax\\Structs\\FareOverrides',
            'FareOverride' => '\\Sabre\\BargainFinderMax\\Structs\\FareOverride',
            'Diagnostics' => '\\Sabre\\BargainFinderMax\\Structs\\Diagnostics',
            'Diagnostic' => '\\Sabre\\BargainFinderMax\\Structs\\Diagnostic',
            'DiagnosticArgument' => '\\Sabre\\BargainFinderMax\\Structs\\DiagnosticArgument',
            'SubagentData' => '\\Sabre\\BargainFinderMax\\Structs\\SubagentData',
            'ResponseSorting' => '\\Sabre\\BargainFinderMax\\Structs\\ResponseSorting',
            'AvailableLevel' => '\\Sabre\\BargainFinderMax\\Structs\\AvailableLevel',
            'ATSETest' => '\\Sabre\\BargainFinderMax\\Structs\\ATSETest',
            'DiversityControlType' => '\\Sabre\\BargainFinderMax\\Structs\\DiversityControlType',
            'LowFareBucket' => '\\Sabre\\BargainFinderMax\\Structs\\LowFareBucket',
            'Dimensions' => '\\Sabre\\BargainFinderMax\\Structs\\Dimensions',
            'TravelTime' => '\\Sabre\\BargainFinderMax\\Structs\\TravelTime',
            'Default' => '\\Sabre\\BargainFinderMax\\Structs\\_Default',
            'Override' => '\\Sabre\\BargainFinderMax\\Structs\\Override',
            'OperatingDuplicate' => '\\Sabre\\BargainFinderMax\\Structs\\OperatingDuplicate',
            'PreferredCarrier' => '\\Sabre\\BargainFinderMax\\Structs\\PreferredCarrier',
            'InboundOutboundPairing' => '\\Sabre\\BargainFinderMax\\Structs\\InboundOutboundPairing',
            'TimeOfDay' => '\\Sabre\\BargainFinderMax\\Structs\\TimeOfDay',
            'Distribution' => '\\Sabre\\BargainFinderMax\\Structs\\Distribution',
            'Range' => '\\Sabre\\BargainFinderMax\\Structs\\Range',
            'StopsNumber' => '\\Sabre\\BargainFinderMax\\Structs\\StopsNumber',
            'AwardShoppingType' => '\\Sabre\\BargainFinderMax\\Structs\\AwardShoppingType',
            'SeatStatusSimType' => '\\Sabre\\BargainFinderMax\\Structs\\SeatStatusSimType',
            'DateRangeType' => '\\Sabre\\BargainFinderMax\\Structs\\DateRangeType',
            'PointOfSaleOverrideType' => '\\Sabre\\BargainFinderMax\\Structs\\PointOfSaleOverrideType',
            'PointOfTicketingOverrideType' => '\\Sabre\\BargainFinderMax\\Structs\\PointOfTicketingOverrideType',
            'ApplyResidentDiscountType' => '\\Sabre\\BargainFinderMax\\Structs\\ApplyResidentDiscountType',
            'RoutingDefinitionType' => '\\Sabre\\BargainFinderMax\\Structs\\RoutingDefinitionType',
            'RoutingLegType' => '\\Sabre\\BargainFinderMax\\Structs\\RoutingLegType',
            'Day' => '\\Sabre\\BargainFinderMax\\Structs\\Day',
            'DaysRange' => '\\Sabre\\BargainFinderMax\\Structs\\DaysRange',
            'SourceBookingChannelType' => '\\Sabre\\BargainFinderMax\\Structs\\SourceBookingChannelType',
            'AirlineType' => '\\Sabre\\BargainFinderMax\\Structs\\AirlineType',
            'ReservationType' => '\\Sabre\\BargainFinderMax\\Structs\\ReservationType',
            'SideTripType' => '\\Sabre\\BargainFinderMax\\Structs\\SideTripType',
            'MileageDisplayType' => '\\Sabre\\BargainFinderMax\\Structs\\MileageDisplayType',
            'IncludeVendorPrefType' => '\\Sabre\\BargainFinderMax\\Structs\\IncludeVendorPrefType',
            'AllianceType' => '\\Sabre\\BargainFinderMax\\Structs\\AllianceType',
            'DepartureDaysType' => '\\Sabre\\BargainFinderMax\\Structs\\DepartureDaysType',
            'OriginDestinationFlightType' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationFlightType',
            'DateFlexibility' => '\\Sabre\\BargainFinderMax\\Structs\\DateFlexibility',
            'SisterDestinationMileage' => '\\Sabre\\BargainFinderMax\\Structs\\SisterDestinationMileage',
            'SisterOriginMileage' => '\\Sabre\\BargainFinderMax\\Structs\\SisterOriginMileage',
            'SegmentType' => '\\Sabre\\BargainFinderMax\\Structs\\SegmentType',
            'AlternateTime' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateTime',
            'MaxOneWayOptions' => '\\Sabre\\BargainFinderMax\\Structs\\MaxOneWayOptions',
            'NumOneWayOptions' => '\\Sabre\\BargainFinderMax\\Structs\\NumOneWayOptions',
            'TotalTravelTime' => '\\Sabre\\BargainFinderMax\\Structs\\TotalTravelTime',
            'NumTripsType' => '\\Sabre\\BargainFinderMax\\Structs\\NumTripsType',
            'AltCitiesCombinationsType' => '\\Sabre\\BargainFinderMax\\Structs\\AltCitiesCombinationsType',
            'XOFaresType' => '\\Sabre\\BargainFinderMax\\Structs\\XOFaresType',
            'FlightStopsAsConnectionsType' => '\\Sabre\\BargainFinderMax\\Structs\\FlightStopsAsConnectionsType',
            'JumpCabinLogicType' => '\\Sabre\\BargainFinderMax\\Structs\\JumpCabinLogicType',
            'KeepSameCabinType' => '\\Sabre\\BargainFinderMax\\Structs\\KeepSameCabinType',
            'GoverningCarrierOverrideType' => '\\Sabre\\BargainFinderMax\\Structs\\GoverningCarrierOverrideType',
            'ValidatingCarrierType' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrierType',
            'Preference' => '\\Sabre\\BargainFinderMax\\Structs\\Preference',
            'RetailerRulesType' => '\\Sabre\\BargainFinderMax\\Structs\\RetailerRulesType',
            'RetailerRule' => '\\Sabre\\BargainFinderMax\\Structs\\RetailerRule',
            'OptionsPerDatePairType' => '\\Sabre\\BargainFinderMax\\Structs\\OptionsPerDatePairType',
            'OnlineIndicator' => '\\Sabre\\BargainFinderMax\\Structs\\OnlineIndicator',
            'InterlineIndicator' => '\\Sabre\\BargainFinderMax\\Structs\\InterlineIndicator',
            'ExemptAllTaxes' => '\\Sabre\\BargainFinderMax\\Structs\\ExemptAllTaxes',
            'ExemptAllTaxesAndFees' => '\\Sabre\\BargainFinderMax\\Structs\\ExemptAllTaxesAndFees',
            'Taxes' => '\\Sabre\\BargainFinderMax\\Structs\\Taxes',
            'BillingInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\BillingInformationType',
            'ExchangeSettingsType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeSettingsType',
            'ExchangeFareType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeFareType',
            'ExchangeSourceType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeSourceType',
            'ExchangePOSType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangePOSType',
            'ArunkType' => '\\Sabre\\BargainFinderMax\\Structs\\ArunkType',
            'FareDetailsType' => '\\Sabre\\BargainFinderMax\\Structs\\FareDetailsType',
            'FareOptionalDetailsType' => '\\Sabre\\BargainFinderMax\\Structs\\FareOptionalDetailsType',
            'PlusUpType' => '\\Sabre\\BargainFinderMax\\Structs\\PlusUpType',
            'SurchargeType' => '\\Sabre\\BargainFinderMax\\Structs\\SurchargeType',
            'Fare' => '\\Sabre\\BargainFinderMax\\Structs\\Fare',
            'Adjustment' => '\\Sabre\\BargainFinderMax\\Structs\\Adjustment',
            'ExchangeOriginDestinationFlightType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeOriginDestinationFlightType',
            'ExchangeOriginDestinationInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeOriginDestinationInformationType',
            'ExchangeTravelPreferencesTPA_ExtensionsType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeTravelPreferencesTPA_ExtensionsType',
            'ExchangeAirSearchPrefsType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeAirSearchPrefsType',
            'ExchangeTPA_ExtensionsType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeTPA_ExtensionsType',
            'ExchangeType' => '\\Sabre\\BargainFinderMax\\Structs\\ExchangeType',
            'FlexibleFaresType' => '\\Sabre\\BargainFinderMax\\Structs\\FlexibleFaresType',
            'FareParameters' => '\\Sabre\\BargainFinderMax\\Structs\\FareParameters',
            'ExcludeRestricted' => '\\Sabre\\BargainFinderMax\\Structs\\ExcludeRestricted',
            'PassengerType' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerType',
            'NegotiatedFaresOnly' => '\\Sabre\\BargainFinderMax\\Structs\\NegotiatedFaresOnly',
            'XOFares' => '\\Sabre\\BargainFinderMax\\Structs\\XOFares',
            'CorporateID' => '\\Sabre\\BargainFinderMax\\Structs\\CorporateID',
            'AlternatePCCType' => '\\Sabre\\BargainFinderMax\\Structs\\AlternatePCCType',
            'TravelPreferences' => '\\Sabre\\BargainFinderMax\\Structs\\TravelPreferences',
            'VendorPref' => '\\Sabre\\BargainFinderMax\\Structs\\VendorPref',
            'InterlineBrandsType' => '\\Sabre\\BargainFinderMax\\Structs\\InterlineBrandsType',
            'BrandType' => '\\Sabre\\BargainFinderMax\\Structs\\BrandType',
            'CachePartitionType' => '\\Sabre\\BargainFinderMax\\Structs\\CachePartitionType',
            'CachePartitionGroupType' => '\\Sabre\\BargainFinderMax\\Structs\\CachePartitionGroupType',
            'OTA_AirLowFareSearchRS' => '\\Sabre\\BargainFinderMax\\Structs\\OTA_AirLowFareSearchRS',
            'PricedItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\PricedItineraries',
            'OneWayItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\OneWayItineraries',
            'BrandedOneWayItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\BrandedOneWayItineraries',
            'SimpleOneWayItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\SimpleOneWayItineraries',
            'DepartedItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\DepartedItineraries',
            'SoldOutItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\SoldOutItineraries',
            'AvailableItineraries' => '\\Sabre\\BargainFinderMax\\Structs\\AvailableItineraries',
            'AirlineOrderList' => '\\Sabre\\BargainFinderMax\\Structs\\AirlineOrderList',
            'AirlineOrder' => '\\Sabre\\BargainFinderMax\\Structs\\AirlineOrder',
            'OriginalItinerary' => '\\Sabre\\BargainFinderMax\\Structs\\OriginalItinerary',
            'Tax' => '\\Sabre\\BargainFinderMax\\Structs\\Tax',
            'AirFeeType' => '\\Sabre\\BargainFinderMax\\Structs\\AirFeeType',
            'OBFeeType' => '\\Sabre\\BargainFinderMax\\Structs\\OBFeeType',
            'OCFeeType' => '\\Sabre\\BargainFinderMax\\Structs\\OCFeeType',
            'ReissueInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\ReissueInfoType',
            'ChangeFees' => '\\Sabre\\BargainFinderMax\\Structs\\ChangeFees',
            'ChangeFee' => '\\Sabre\\BargainFinderMax\\Structs\\ChangeFee',
            'ItinTotalFareType' => '\\Sabre\\BargainFinderMax\\Structs\\ItinTotalFareType',
            'Extras' => '\\Sabre\\BargainFinderMax\\Structs\\Extras',
            'TotalWithExtras' => '\\Sabre\\BargainFinderMax\\Structs\\TotalWithExtras',
            'TotalMileage' => '\\Sabre\\BargainFinderMax\\Structs\\TotalMileage',
            'ServiceFee' => '\\Sabre\\BargainFinderMax\\Structs\\ServiceFee',
            'TicketsPricingType' => '\\Sabre\\BargainFinderMax\\Structs\\TicketsPricingType',
            'TicketPricingType' => '\\Sabre\\BargainFinderMax\\Structs\\TicketPricingType',
            'OriginDestinationOptions' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationOptions',
            'OriginDestinationOption' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationOption',
            'FlightSegment' => '\\Sabre\\BargainFinderMax\\Structs\\FlightSegment',
            'ValidatingCarrier' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrier',
            'AirItineraryPricingInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\AirItineraryPricingInfoType',
            'PTC_FareBreakdowns' => '\\Sabre\\BargainFinderMax\\Structs\\PTC_FareBreakdowns',
            'FareInfos' => '\\Sabre\\BargainFinderMax\\Structs\\FareInfos',
            'FareInfo' => '\\Sabre\\BargainFinderMax\\Structs\\FareInfo',
            'SeatsRemaining' => '\\Sabre\\BargainFinderMax\\Structs\\SeatsRemaining',
            'FareNote' => '\\Sabre\\BargainFinderMax\\Structs\\FareNote',
            'Meal' => '\\Sabre\\BargainFinderMax\\Structs\\Meal',
            'Rule' => '\\Sabre\\BargainFinderMax\\Structs\\Rule',
            'DivideInParty' => '\\Sabre\\BargainFinderMax\\Structs\\DivideInParty',
            'PromoOffer' => '\\Sabre\\BargainFinderMax\\Structs\\PromoOffer',
            'PromoRedemption' => '\\Sabre\\BargainFinderMax\\Structs\\PromoRedemption',
            'AncillaryFeeGroups' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeGroups',
            'AncillaryFeeItem' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeItem',
            'Legs' => '\\Sabre\\BargainFinderMax\\Structs\\Legs',
            'Segment' => '\\Sabre\\BargainFinderMax\\Structs\\Segment',
            'ProcessingMessageType' => '\\Sabre\\BargainFinderMax\\Structs\\ProcessingMessageType',
            'OneWayProcessingMessageType' => '\\Sabre\\BargainFinderMax\\Structs\\OneWayProcessingMessageType',
            'ComplexProcessingMessageType' => '\\Sabre\\BargainFinderMax\\Structs\\ComplexProcessingMessageType',
            'AirItineraryType' => '\\Sabre\\BargainFinderMax\\Structs\\AirItineraryType',
            'AirTaxType' => '\\Sabre\\BargainFinderMax\\Structs\\AirTaxType',
            'AirTaxSummaryType' => '\\Sabre\\BargainFinderMax\\Structs\\AirTaxSummaryType',
            'BookFlightSegmentType' => '\\Sabre\\BargainFinderMax\\Structs\\BookFlightSegmentType',
            'StopAirports' => '\\Sabre\\BargainFinderMax\\Structs\\StopAirports',
            'StopAirport' => '\\Sabre\\BargainFinderMax\\Structs\\StopAirport',
            'DepartureTimeZone' => '\\Sabre\\BargainFinderMax\\Structs\\DepartureTimeZone',
            'ArrivalTimeZone' => '\\Sabre\\BargainFinderMax\\Structs\\ArrivalTimeZone',
            'OnTimePerformance' => '\\Sabre\\BargainFinderMax\\Structs\\OnTimePerformance',
            'eTicket' => '\\Sabre\\BargainFinderMax\\Structs\\ETicket',
            'DataElement' => '\\Sabre\\BargainFinderMax\\Structs\\DataElement',
            'Mileage' => '\\Sabre\\BargainFinderMax\\Structs\\Mileage',
            'Message' => '\\Sabre\\BargainFinderMax\\Structs\\Message',
            'FareInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\FareInfoType',
            'HandlingMarkupSummaryType' => '\\Sabre\\BargainFinderMax\\Structs\\HandlingMarkupSummaryType',
            'SellingFareDataType' => '\\Sabre\\BargainFinderMax\\Structs\\SellingFareDataType',
            'VCCInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\VCCInformationType',
            'FareComponentBreakdownType' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponentBreakdownType',
            'FareType' => '\\Sabre\\BargainFinderMax\\Structs\\FareType',
            'EquivFare' => '\\Sabre\\BargainFinderMax\\Structs\\EquivFare',
            'FareComponentsTaxes' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponentsTaxes',
            'LegsTaxes' => '\\Sabre\\BargainFinderMax\\Structs\\LegsTaxes',
            'LegTaxes' => '\\Sabre\\BargainFinderMax\\Structs\\LegTaxes',
            'Fees' => '\\Sabre\\BargainFinderMax\\Structs\\Fees',
            'ReissueInfoList' => '\\Sabre\\BargainFinderMax\\Structs\\ReissueInfoList',
            'PenaltiesInfo' => '\\Sabre\\BargainFinderMax\\Structs\\PenaltiesInfo',
            'Cat16TextOnly' => '\\Sabre\\BargainFinderMax\\Structs\\Cat16TextOnly',
            'FareComponents' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponents',
            'FareComponent' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponent',
            'HandlingMarkupDetail' => '\\Sabre\\BargainFinderMax\\Structs\\HandlingMarkupDetail',
            'FareRetailerRule' => '\\Sabre\\BargainFinderMax\\Structs\\FareRetailerRule',
            'SellingFareDataList' => '\\Sabre\\BargainFinderMax\\Structs\\SellingFareDataList',
            'CommissionData' => '\\Sabre\\BargainFinderMax\\Structs\\CommissionData',
            'ValidatingCarrierInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrierInfoType',
            'CarrierCountriesType' => '\\Sabre\\BargainFinderMax\\Structs\\CarrierCountriesType',
            'IETCountryWOBSP' => '\\Sabre\\BargainFinderMax\\Structs\\IETCountryWOBSP',
            'FareMessagesType' => '\\Sabre\\BargainFinderMax\\Structs\\FareMessagesType',
            'RateOfExchangeType' => '\\Sabre\\BargainFinderMax\\Structs\\RateOfExchangeType',
            'CurrencyConversionsType' => '\\Sabre\\BargainFinderMax\\Structs\\CurrencyConversionsType',
            'Conversion' => '\\Sabre\\BargainFinderMax\\Structs\\Conversion',
            'OriginDestinationOptionType' => '\\Sabre\\BargainFinderMax\\Structs\\OriginDestinationOptionType',
            'PTCFareBreakdownType' => '\\Sabre\\BargainFinderMax\\Structs\\PTCFareBreakdownType',
            'FareBasisCodes' => '\\Sabre\\BargainFinderMax\\Structs\\FareBasisCodes',
            'FareBasisCode' => '\\Sabre\\BargainFinderMax\\Structs\\FareBasisCode',
            'Endorsements' => '\\Sabre\\BargainFinderMax\\Structs\\Endorsements',
            'Endorsement' => '\\Sabre\\BargainFinderMax\\Structs\\Endorsement',
            'PricedItinerariesType' => '\\Sabre\\BargainFinderMax\\Structs\\PricedItinerariesType',
            'PricedItineraryType' => '\\Sabre\\BargainFinderMax\\Structs\\PricedItineraryType',
            'AirItineraryPricingInfo' => '\\Sabre\\BargainFinderMax\\Structs\\AirItineraryPricingInfo',
            'AdditionalFares' => '\\Sabre\\BargainFinderMax\\Structs\\AdditionalFares',
            'Ops' => '\\Sabre\\BargainFinderMax\\Structs\\Ops',
            'FareTypes' => '\\Sabre\\BargainFinderMax\\Structs\\FareTypes',
            'ItinSource' => '\\Sabre\\BargainFinderMax\\Structs\\ItinSource',
            'ValueBucket' => '\\Sabre\\BargainFinderMax\\Structs\\ValueBucket',
            'DiversitySwapper' => '\\Sabre\\BargainFinderMax\\Structs\\DiversitySwapper',
            'Failed' => '\\Sabre\\BargainFinderMax\\Structs\\Failed',
            'RuleInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\RuleInfoType',
            'ResTicketingRules' => '\\Sabre\\BargainFinderMax\\Structs\\ResTicketingRules',
            'TicketingInfoRS_Type' => '\\Sabre\\BargainFinderMax\\Structs\\TicketingInfoRS_Type',
            'CurrencyAmountType' => '\\Sabre\\BargainFinderMax\\Structs\\CurrencyAmountType',
            'ErrorType' => '\\Sabre\\BargainFinderMax\\Structs\\ErrorType',
            'ErrorsType' => '\\Sabre\\BargainFinderMax\\Structs\\ErrorsType',
            'FreeTextType' => '\\Sabre\\BargainFinderMax\\Structs\\FreeTextType',
            'ResponseLocationType' => '\\Sabre\\BargainFinderMax\\Structs\\ResponseLocationType',
            'AirportInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\AirportInformationType',
            'OperatingAirlineType' => '\\Sabre\\BargainFinderMax\\Structs\\OperatingAirlineType',
            'SuccessType' => '\\Sabre\\BargainFinderMax\\Structs\\SuccessType',
            'WarningType' => '\\Sabre\\BargainFinderMax\\Structs\\WarningType',
            'WarningsType' => '\\Sabre\\BargainFinderMax\\Structs\\WarningsType',
            'FareCalcLineType' => '\\Sabre\\BargainFinderMax\\Structs\\FareCalcLineType',
            'FareGroupType' => '\\Sabre\\BargainFinderMax\\Structs\\FareGroupType',
            'CouponOfferType' => '\\Sabre\\BargainFinderMax\\Structs\\CouponOfferType',
            'AlternateLocationLowestFaresType' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateLocationLowestFaresType',
            'AlternateDateLowestFaresType' => '\\Sabre\\BargainFinderMax\\Structs\\AlternateDateLowestFaresType',
            'AirlineLowestFaresType' => '\\Sabre\\BargainFinderMax\\Structs\\AirlineLowestFaresType',
            'SurchargesType' => '\\Sabre\\BargainFinderMax\\Structs\\SurchargesType',
            'FareComponentTaxesType' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponentTaxesType',
            'UnflownPriceType' => '\\Sabre\\BargainFinderMax\\Structs\\UnflownPriceType',
            'BaggageInformationListType' => '\\Sabre\\BargainFinderMax\\Structs\\BaggageInformationListType',
            'BaggageInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\BaggageInformationType',
            'Allowance' => '\\Sabre\\BargainFinderMax\\Structs\\Allowance',
            'Charge' => '\\Sabre\\BargainFinderMax\\Structs\\Charge',
            'BrandFeatureRefType' => '\\Sabre\\BargainFinderMax\\Structs\\BrandFeatureRefType',
            'BrandFeatureType' => '\\Sabre\\BargainFinderMax\\Structs\\BrandFeatureType',
            'BrandFeatureListType' => '\\Sabre\\BargainFinderMax\\Structs\\BrandFeatureListType',
            'GroupedItineraryResponse' => '\\Sabre\\BargainFinderMax\\Structs\\GroupedItineraryResponse',
            'SurfaceType' => '\\Sabre\\BargainFinderMax\\Structs\\SurfaceType',
            'CurrencyConversionType' => '\\Sabre\\BargainFinderMax\\Structs\\CurrencyConversionType',
            'ChangeFeeType' => '\\Sabre\\BargainFinderMax\\Structs\\ChangeFeeType',
            'FareComponentIDType' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponentIDType',
            'GroupDescriptionType' => '\\Sabre\\BargainFinderMax\\Structs\\GroupDescriptionType',
            'ScheduleType' => '\\Sabre\\BargainFinderMax\\Structs\\ScheduleType',
            'LegIDType' => '\\Sabre\\BargainFinderMax\\Structs\\LegIDType',
            'BrandFeatureIDType' => '\\Sabre\\BargainFinderMax\\Structs\\BrandFeatureIDType',
            'ScheduleMessageType' => '\\Sabre\\BargainFinderMax\\Structs\\ScheduleMessageType',
            'ItineraryGroupType' => '\\Sabre\\BargainFinderMax\\Structs\\ItineraryGroupType',
            'GroupDescription' => '\\Sabre\\BargainFinderMax\\Structs\\GroupDescription',
            'HigherIntermediatePointType' => '\\Sabre\\BargainFinderMax\\Structs\\HigherIntermediatePointType',
            'ItineraryType' => '\\Sabre\\BargainFinderMax\\Structs\\ItineraryType',
            'LegDescriptionType' => '\\Sabre\\BargainFinderMax\\Structs\\LegDescriptionType',
            'LegType' => '\\Sabre\\BargainFinderMax\\Structs\\LegType',
            'MessageType' => '\\Sabre\\BargainFinderMax\\Structs\\MessageType',
            'AncillaryFeeDetailsType' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeDetailsType',
            'FareMessageType' => '\\Sabre\\BargainFinderMax\\Structs\\FareMessageType',
            'HiddenStopType' => '\\Sabre\\BargainFinderMax\\Structs\\HiddenStopType',
            'DiversitySwapperType' => '\\Sabre\\BargainFinderMax\\Structs\\DiversitySwapperType',
            'PricingInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\PricingInformationType',
            'Cached' => '\\Sabre\\BargainFinderMax\\Structs\\Cached',
            'SoldOutType' => '\\Sabre\\BargainFinderMax\\Structs\\SoldOutType',
            'SoldOutLegType' => '\\Sabre\\BargainFinderMax\\Structs\\SoldOutLegType',
            'SoldOutSchedule' => '\\Sabre\\BargainFinderMax\\Structs\\SoldOutSchedule',
            'PassengerTotalFareType' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerTotalFareType',
            'PlusUpInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\PlusUpInformationType',
            'HandlingMarkupDetailType' => '\\Sabre\\BargainFinderMax\\Structs\\HandlingMarkupDetailType',
            'HandlingMarkupType' => '\\Sabre\\BargainFinderMax\\Structs\\HandlingMarkupType',
            'PassengerInformationType' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerInformationType',
            'PassengerNotAvailableInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\PassengerNotAvailableInfoType',
            'ReissueType' => '\\Sabre\\BargainFinderMax\\Structs\\ReissueType',
            'ScheduleDescType' => '\\Sabre\\BargainFinderMax\\Structs\\ScheduleDescType',
            'Departure' => '\\Sabre\\BargainFinderMax\\Structs\\Departure',
            'Arrival' => '\\Sabre\\BargainFinderMax\\Structs\\Arrival',
            'Equipment' => '\\Sabre\\BargainFinderMax\\Structs\\Equipment',
            'BookingDetails' => '\\Sabre\\BargainFinderMax\\Structs\\BookingDetails',
            'FareSegmentType' => '\\Sabre\\BargainFinderMax\\Structs\\FareSegmentType',
            'SideTrip' => '\\Sabre\\BargainFinderMax\\Structs\\SideTrip',
            'AncillaryFeeType' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeType',
            'AncillaryFeeGroupType' => '\\Sabre\\BargainFinderMax\\Structs\\AncillaryFeeGroupType',
            'StatisticsType' => '\\Sabre\\BargainFinderMax\\Structs\\StatisticsType',
            'TaxType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxType',
            'TaxIDType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxIDType',
            'TaxSummaryType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxSummaryType',
            'TaxSummaryIDType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxSummaryIDType',
            'OBFeeIDType' => '\\Sabre\\BargainFinderMax\\Structs\\OBFeeIDType',
            'TotalFareType' => '\\Sabre\\BargainFinderMax\\Structs\\TotalFareType',
            'FareComponentType' => '\\Sabre\\BargainFinderMax\\Structs\\FareComponentType',
            'TaxReissueType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxReissueType',
            'TaxRestrictionsType' => '\\Sabre\\BargainFinderMax\\Structs\\TaxRestrictionsType',
            'PricingLegType' => '\\Sabre\\BargainFinderMax\\Structs\\PricingLegType',
            'ValidatingCarrierCommissionInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrierCommissionInfoType',
            'PenaltiesType' => '\\Sabre\\BargainFinderMax\\Structs\\PenaltiesType',
            'BaggageAllowanceType' => '\\Sabre\\BargainFinderMax\\Structs\\BaggageAllowanceType',
            'BaggageChargeType' => '\\Sabre\\BargainFinderMax\\Structs\\BaggageChargeType',
            'CacheSourceDescType' => '\\Sabre\\BargainFinderMax\\Structs\\CacheSourceDescType',
            'ValidatingCarrierIDType' => '\\Sabre\\BargainFinderMax\\Structs\\ValidatingCarrierIDType',
            'FailedType' => '\\Sabre\\BargainFinderMax\\Structs\\FailedType',
            'SignatureType' => '\\Sabre\\BargainFinderMax\\Structs\\SignatureType',
            'SignatureValueType' => '\\Sabre\\BargainFinderMax\\Structs\\SignatureValueType',
            'SignedInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\SignedInfoType',
            'CanonicalizationMethodType' => '\\Sabre\\BargainFinderMax\\Structs\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\Sabre\\BargainFinderMax\\Structs\\SignatureMethodType',
            'ReferenceType' => '\\Sabre\\BargainFinderMax\\Structs\\ReferenceType',
            'TransformsType' => '\\Sabre\\BargainFinderMax\\Structs\\TransformsType',
            'TransformType' => '\\Sabre\\BargainFinderMax\\Structs\\TransformType',
            'DigestMethodType' => '\\Sabre\\BargainFinderMax\\Structs\\DigestMethodType',
            'KeyInfoType' => '\\Sabre\\BargainFinderMax\\Structs\\KeyInfoType',
            'KeyValueType' => '\\Sabre\\BargainFinderMax\\Structs\\KeyValueType',
            'RetrievalMethodType' => '\\Sabre\\BargainFinderMax\\Structs\\RetrievalMethodType',
            'X509DataType' => '\\Sabre\\BargainFinderMax\\Structs\\X509DataType',
            'X509IssuerSerialType' => '\\Sabre\\BargainFinderMax\\Structs\\X509IssuerSerialType',
            'PGPDataType' => '\\Sabre\\BargainFinderMax\\Structs\\PGPDataType',
            'SPKIDataType' => '\\Sabre\\BargainFinderMax\\Structs\\SPKIDataType',
            'ObjectType' => '\\Sabre\\BargainFinderMax\\Structs\\ObjectType',
            'ManifestType' => '\\Sabre\\BargainFinderMax\\Structs\\ManifestType',
            'SignaturePropertiesType' => '\\Sabre\\BargainFinderMax\\Structs\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\Sabre\\BargainFinderMax\\Structs\\SignaturePropertyType',
            'DSAKeyValueType' => '\\Sabre\\BargainFinderMax\\Structs\\DSAKeyValueType',
            'RSAKeyValueType' => '\\Sabre\\BargainFinderMax\\Structs\\RSAKeyValueType',
            'Envelope' => '\\Sabre\\BargainFinderMax\\Structs\\Envelope',
            'Header' => '\\Sabre\\BargainFinderMax\\Structs\\Header',
            'Body' => '\\Sabre\\BargainFinderMax\\Structs\\Body',
            'Fault' => '\\Sabre\\BargainFinderMax\\Structs\\Fault',
            'detail' => '\\Sabre\\BargainFinderMax\\Structs\\Detail',
            'Manifest' => '\\Sabre\\BargainFinderMax\\Structs\\Manifest',
            'Reference' => '\\Sabre\\BargainFinderMax\\Structs\\Reference',
            'Schema' => '\\Sabre\\BargainFinderMax\\Structs\\Schema',
            'MessageHeader' => '\\Sabre\\BargainFinderMax\\Structs\\MessageHeader',
            'Service' => '\\Sabre\\BargainFinderMax\\Structs\\Service',
            'MessageData' => '\\Sabre\\BargainFinderMax\\Structs\\MessageData',
            'SyncReply' => '\\Sabre\\BargainFinderMax\\Structs\\SyncReply',
            'MessageOrder' => '\\Sabre\\BargainFinderMax\\Structs\\MessageOrder',
            'AckRequested' => '\\Sabre\\BargainFinderMax\\Structs\\AckRequested',
            'Acknowledgment' => '\\Sabre\\BargainFinderMax\\Structs\\Acknowledgment',
            'ErrorList' => '\\Sabre\\BargainFinderMax\\Structs\\ErrorList',
            'Error' => '\\Sabre\\BargainFinderMax\\Structs\\Error',
            'StatusResponse' => '\\Sabre\\BargainFinderMax\\Structs\\StatusResponse',
            'StatusRequest' => '\\Sabre\\BargainFinderMax\\Structs\\StatusRequest',
            'sequenceNumber.type' => '\\Sabre\\BargainFinderMax\\Structs\\SequenceNumber_type',
            'PartyId' => '\\Sabre\\BargainFinderMax\\Structs\\PartyId',
            'To' => '\\Sabre\\BargainFinderMax\\Structs\\To',
            'From' => '\\Sabre\\BargainFinderMax\\Structs\\From',
            'Description' => '\\Sabre\\BargainFinderMax\\Structs\\Description',
            'Security' => '\\Sabre\\BargainFinderMax\\Structs\\Security',
            'UsernameToken' => '\\Sabre\\BargainFinderMax\\Structs\\UsernameToken',
        );
    }
}
