<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AirlineLowestFaresType Structs
 * Meta informations extracted from the WSDL
 * - documentation: IntelliSell Type . lowest fare for airline. Currently not used.
 * @subpackage Structs
 */
class AirlineLowestFaresType extends AbstractStructBase
{
    /**
     * The Airline
     * @var \Sabre\BargainFinderMax\Structs\CompanyNameType
     */
    public $Airline;
    /**
     * The NoStops
     * @var int
     */
    public $NoStops;
    /**
     * The LowestFare
     * @var \Sabre\BargainFinderMax\Structs\CurrencyAmountType
     */
    public $LowestFare;
    /**
     * The ItineraryCount
     * @var mixed
     */
    public $ItineraryCount;
    /**
     * Constructor method for AirlineLowestFaresType
     * @uses AirlineLowestFaresType::setAirline()
     * @uses AirlineLowestFaresType::setNoStops()
     * @uses AirlineLowestFaresType::setLowestFare()
     * @uses AirlineLowestFaresType::setItineraryCount()
     * @param \Sabre\BargainFinderMax\Structs\CompanyNameType $airline
     * @param int $noStops
     * @param \Sabre\BargainFinderMax\Structs\CurrencyAmountType $lowestFare
     * @param mixed $itineraryCount
     */
    public function __construct(\Sabre\BargainFinderMax\Structs\CompanyNameType $airline = null, $noStops = null, \Sabre\BargainFinderMax\Structs\CurrencyAmountType $lowestFare = null, $itineraryCount = null)
    {
        $this
            ->setAirline($airline)
            ->setNoStops($noStops)
            ->setLowestFare($lowestFare)
            ->setItineraryCount($itineraryCount);
    }
    /**
     * Get Airline value
     * @return \Sabre\BargainFinderMax\Structs\CompanyNameType|null
     */
    public function getAirline()
    {
        return $this->Airline;
    }
    /**
     * Set Airline value
     * @param \Sabre\BargainFinderMax\Structs\CompanyNameType $airline
     * @return \Sabre\BargainFinderMax\Structs\AirlineLowestFaresType
     */
    public function setAirline(\Sabre\BargainFinderMax\Structs\CompanyNameType $airline = null)
    {
        $this->Airline = $airline;
        return $this;
    }
    /**
     * Get NoStops value
     * @return int|null
     */
    public function getNoStops()
    {
        return $this->NoStops;
    }
    /**
     * Set NoStops value
     * @param int $noStops
     * @return \Sabre\BargainFinderMax\Structs\AirlineLowestFaresType
     */
    public function setNoStops($noStops = null)
    {
        $this->NoStops = $noStops;
        return $this;
    }
    /**
     * Get LowestFare value
     * @return \Sabre\BargainFinderMax\Structs\CurrencyAmountType|null
     */
    public function getLowestFare()
    {
        return $this->LowestFare;
    }
    /**
     * Set LowestFare value
     * @param \Sabre\BargainFinderMax\Structs\CurrencyAmountType $lowestFare
     * @return \Sabre\BargainFinderMax\Structs\AirlineLowestFaresType
     */
    public function setLowestFare(\Sabre\BargainFinderMax\Structs\CurrencyAmountType $lowestFare = null)
    {
        $this->LowestFare = $lowestFare;
        return $this;
    }
    /**
     * Get ItineraryCount value
     * @return mixed|null
     */
    public function getItineraryCount()
    {
        return $this->ItineraryCount;
    }
    /**
     * Set ItineraryCount value
     * @param mixed $itineraryCount
     * @return \Sabre\BargainFinderMax\Structs\AirlineLowestFaresType
     */
    public function setItineraryCount($itineraryCount = null)
    {
        $this->ItineraryCount = $itineraryCount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\AirlineLowestFaresType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
