<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EquipmentType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Specifies the aircraft equipment type.
 * @subpackage Structs
 */
class EquipmentType extends AbstractStructBase
{
    /**
     * The AirEquipType
     * Meta informations extracted from the WSDL
     * - documentation: This is the 3 character IATA code. | Used for Strings, length exactly 3
     * - use: required
     * - maxLength: 3
     * - minLength: 3
     * @var string
     */
    public $AirEquipType;
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The ChangeofGauge
     * Meta informations extracted from the WSDL
     * - default: false
     * - documentation: Indicates there is an equipment change.
     * - use: optional
     * @var bool
     */
    public $ChangeofGauge;
    /**
     * Constructor method for EquipmentType
     * @uses EquipmentType::setAirEquipType()
     * @uses EquipmentType::set_()
     * @uses EquipmentType::setChangeofGauge()
     * @param string $airEquipType
     * @param string $_
     * @param bool $changeofGauge
     */
    public function __construct($airEquipType = null, $_ = null, $changeofGauge = false)
    {
        $this
            ->setAirEquipType($airEquipType)
            ->set_($_)
            ->setChangeofGauge($changeofGauge);
    }
    /**
     * Get AirEquipType value
     * @return string
     */
    public function getAirEquipType()
    {
        return $this->AirEquipType;
    }
    /**
     * Set AirEquipType value
     * @param string $airEquipType
     * @return \Sabre\BargainFinderMax\Structs\EquipmentType
     */
    public function setAirEquipType($airEquipType = null)
    {
        $this->AirEquipType = $airEquipType;
        return $this;
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \Sabre\BargainFinderMax\Structs\EquipmentType
     */
    public function set_($_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get ChangeofGauge value
     * @return bool|null
     */
    public function getChangeofGauge()
    {
        return $this->ChangeofGauge;
    }
    /**
     * Set ChangeofGauge value
     * @param bool $changeofGauge
     * @return \Sabre\BargainFinderMax\Structs\EquipmentType
     */
    public function setChangeofGauge($changeofGauge = false)
    {
        $this->ChangeofGauge = $changeofGauge;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\EquipmentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
