<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareMessageType Structs
 * @subpackage Structs
 */
class FareMessageType extends AbstractStructBase
{
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - documentation: Type
     * - use: required
     * @var string
     */
    public $Type;
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - documentation: Code
     * - use: required
     * @var string
     */
    public $Code;
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The Carrier
     * Meta informations extracted from the WSDL
     * - documentation: Carrier | Airline carrier code type
     * - pattern: \*\*
     * @var string
     */
    public $Carrier;
    /**
     * The Info
     * Meta informations extracted from the WSDL
     * - documentation: Short description
     * @var string
     */
    public $Info;
    /**
     * Constructor method for FareMessageType
     * @uses FareMessageType::setType()
     * @uses FareMessageType::setCode()
     * @uses FareMessageType::set_()
     * @uses FareMessageType::setCarrier()
     * @uses FareMessageType::setInfo()
     * @param string $type
     * @param string $code
     * @param string $_
     * @param string $carrier
     * @param string $info
     */
    public function __construct($type = null, $code = null, $_ = null, $carrier = null, $info = null)
    {
        $this
            ->setType($type)
            ->setCode($code)
            ->set_($_)
            ->setCarrier($carrier)
            ->setInfo($info);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public function setType($type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Code value
     * @return string
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public function setCode($code = null)
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public function set_($_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Get Carrier value
     * @return string|null
     */
    public function getCarrier()
    {
        return $this->Carrier;
    }
    /**
     * Set Carrier value
     * @param string $carrier
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public function setCarrier($carrier = null)
    {
        $this->Carrier = $carrier;
        return $this;
    }
    /**
     * Get Info value
     * @return string|null
     */
    public function getInfo()
    {
        return $this->Info;
    }
    /**
     * Set Info value
     * @param string $info
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public function setInfo($info = null)
    {
        $this->Info = $info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\FareMessageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
