<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareRetailerRule Structs
 * Meta informations extracted from the WSDL
 * - documentation: Matched General Retailer Rule Code or Adjusted Selling Level Retailer Rule Code
 * @subpackage Structs
 */
class FareRetailerRule extends AbstractStructBase
{
    /**
     * The TransactionType
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $TransactionType;
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Code;
    /**
     * Constructor method for FareRetailerRule
     * @uses FareRetailerRule::setTransactionType()
     * @uses FareRetailerRule::setCode()
     * @param string $transactionType
     * @param string $code
     */
    public function __construct($transactionType = null, $code = null)
    {
        $this
            ->setTransactionType($transactionType)
            ->setCode($code);
    }
    /**
     * Get TransactionType value
     * @return string
     */
    public function getTransactionType()
    {
        return $this->TransactionType;
    }
    /**
     * Set TransactionType value
     * @param string $transactionType
     * @return \Sabre\BargainFinderMax\Structs\FareRetailerRule
     */
    public function setTransactionType($transactionType = null)
    {
        $this->TransactionType = $transactionType;
        return $this;
    }
    /**
     * Get Code value
     * @return string
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Sabre\BargainFinderMax\Structs\FareRetailerRule
     */
    public function setCode($code = null)
    {
        $this->Code = $code;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\FareRetailerRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
