<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LongConnectPoints Structs
 * Meta informations extracted from the WSDL
 * - documentation: Minimum and maximum number of connection points (not necessarily long) for Long Connections.
 * @subpackage Structs
 */
class LongConnectPoints extends AbstractStructBase
{
    /**
     * The Min
     * @var int
     */
    public $Min;
    /**
     * The Max
     * @var int
     */
    public $Max;
    /**
     * Constructor method for LongConnectPoints
     * @uses LongConnectPoints::setMin()
     * @uses LongConnectPoints::setMax()
     * @param int $min
     * @param int $max
     */
    public function __construct($min = null, $max = null)
    {
        $this
            ->setMin($min)
            ->setMax($max);
    }
    /**
     * Get Min value
     * @return int|null
     */
    public function getMin()
    {
        return $this->Min;
    }
    /**
     * Set Min value
     * @param int $min
     * @return \Sabre\BargainFinderMax\Structs\LongConnectPoints
     */
    public function setMin($min = null)
    {
        $this->Min = $min;
        return $this;
    }
    /**
     * Get Max value
     * @return int|null
     */
    public function getMax()
    {
        return $this->Max;
    }
    /**
     * Set Max value
     * @param int $max
     * @return \Sabre\BargainFinderMax\Structs\LongConnectPoints
     */
    public function setMax($max = null)
    {
        $this->Max = $max;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\LongConnectPoints
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
