<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MultiAirportCodes Structs
 * Meta informations extracted from the WSDL
 * - documentation: Settings specific to Multi Airport Codes processing
 * @subpackage Structs
 */
class MultiAirportCodes extends AbstractStructBase
{
    /**
     * The EnableOpenJaw
     * Meta informations extracted from the WSDL
     * - default: false
     * - documentation: Enable open jaw leg combinations.
     * @var bool
     */
    public $EnableOpenJaw;
    /**
     * Constructor method for MultiAirportCodes
     * @uses MultiAirportCodes::setEnableOpenJaw()
     * @param bool $enableOpenJaw
     */
    public function __construct($enableOpenJaw = false)
    {
        $this
            ->setEnableOpenJaw($enableOpenJaw);
    }
    /**
     * Get EnableOpenJaw value
     * @return bool|null
     */
    public function getEnableOpenJaw()
    {
        return $this->EnableOpenJaw;
    }
    /**
     * Set EnableOpenJaw value
     * @param bool $enableOpenJaw
     * @return \Sabre\BargainFinderMax\Structs\MultiAirportCodes
     */
    public function setEnableOpenJaw($enableOpenJaw = false)
    {
        $this->EnableOpenJaw = $enableOpenJaw;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\MultiAirportCodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
