<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OnTimePerformance Structs
 * Meta informations extracted from the WSDL
 * - documentation: DEI502 On time performance indicator
 * - maxInclusive: 100
 * - minInclusive: 0
 * @subpackage Structs
 */
class OnTimePerformance extends AbstractStructBase
{
    /**
     * The Level
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Level;
    /**
     * The Percentage
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $Percentage;
    /**
     * Constructor method for OnTimePerformance
     * @uses OnTimePerformance::setLevel()
     * @uses OnTimePerformance::setPercentage()
     * @param string $level
     * @param string $percentage
     */
    public function __construct($level = null, $percentage = null)
    {
        $this
            ->setLevel($level)
            ->setPercentage($percentage);
    }
    /**
     * Get Level value
     * @return string|null
     */
    public function getLevel()
    {
        return $this->Level;
    }
    /**
     * Set Level value
     * @param string $level
     * @return \Sabre\BargainFinderMax\Structs\OnTimePerformance
     */
    public function setLevel($level = null)
    {
        $this->Level = $level;
        return $this;
    }
    /**
     * Get Percentage value
     * @return string|null
     */
    public function getPercentage()
    {
        return $this->Percentage;
    }
    /**
     * Set Percentage value
     * @param string $percentage
     * @return \Sabre\BargainFinderMax\Structs\OnTimePerformance
     */
    public function setPercentage($percentage = null)
    {
        $this->Percentage = $percentage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\OnTimePerformance
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
