<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OneWayProcessingMessageType Structs
 * @subpackage Structs
 */
class OneWayProcessingMessageType extends ProcessingMessageType
{
    /**
     * The DepartureDate
     * Meta informations extracted from the WSDL
     * - documentation: Departure date
     * - use: optional
     * @var string
     */
    public $DepartureDate;
    /**
     * The DepartureAirport
     * Meta informations extracted from the WSDL
     * - documentation: Location identifying code. | Used for Character Strings, length 1 to 8
     * - use: optional
     * - maxLength: 8
     * - minLength: 1
     * @var string
     */
    public $DepartureAirport;
    /**
     * The ArrivalAirport
     * Meta informations extracted from the WSDL
     * - documentation: Location identifying code. | Used for Character Strings, length 1 to 8
     * - use: optional
     * - maxLength: 8
     * - minLength: 1
     * @var string
     */
    public $ArrivalAirport;
    /**
     * Constructor method for OneWayProcessingMessageType
     * @uses OneWayProcessingMessageType::setDepartureDate()
     * @uses OneWayProcessingMessageType::setDepartureAirport()
     * @uses OneWayProcessingMessageType::setArrivalAirport()
     * @param string $departureDate
     * @param string $departureAirport
     * @param string $arrivalAirport
     */
    public function __construct($departureDate = null, $departureAirport = null, $arrivalAirport = null)
    {
        $this
            ->setDepartureDate($departureDate)
            ->setDepartureAirport($departureAirport)
            ->setArrivalAirport($arrivalAirport);
    }
    /**
     * Get DepartureDate value
     * @return string|null
     */
    public function getDepartureDate()
    {
        return $this->DepartureDate;
    }
    /**
     * Set DepartureDate value
     * @param string $departureDate
     * @return \Sabre\BargainFinderMax\Structs\OneWayProcessingMessageType
     */
    public function setDepartureDate($departureDate = null)
    {
        $this->DepartureDate = $departureDate;
        return $this;
    }
    /**
     * Get DepartureAirport value
     * @return string|null
     */
    public function getDepartureAirport()
    {
        return $this->DepartureAirport;
    }
    /**
     * Set DepartureAirport value
     * @param string $departureAirport
     * @return \Sabre\BargainFinderMax\Structs\OneWayProcessingMessageType
     */
    public function setDepartureAirport($departureAirport = null)
    {
        $this->DepartureAirport = $departureAirport;
        return $this;
    }
    /**
     * Get ArrivalAirport value
     * @return string|null
     */
    public function getArrivalAirport()
    {
        return $this->ArrivalAirport;
    }
    /**
     * Set ArrivalAirport value
     * @param string $arrivalAirport
     * @return \Sabre\BargainFinderMax\Structs\OneWayProcessingMessageType
     */
    public function setArrivalAirport($arrivalAirport = null)
    {
        $this->ArrivalAirport = $arrivalAirport;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\OneWayProcessingMessageType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
