<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OriginDestinationOptions Structs
 * Meta informations extracted from the WSDL
 * - documentation: Indicates which flights are covered by this ticket | A collection of OriginDestinationOption
 * @subpackage Structs
 */
class OriginDestinationOptions extends AbstractStructBase
{
    /**
     * The OriginDestinationOption
     * Meta informations extracted from the WSDL
     * - documentation: A container for flight segments.
     * - maxOccurs: 99
     * @var \Sabre\BargainFinderMax\Structs\OriginDestinationOption[]
     */
    public $OriginDestinationOption;
    /**
     * Constructor method for OriginDestinationOptions
     * @uses OriginDestinationOptions::setOriginDestinationOption()
     * @param \Sabre\BargainFinderMax\Structs\OriginDestinationOption[] $originDestinationOption
     */
    public function __construct(array $originDestinationOption = array())
    {
        $this
            ->setOriginDestinationOption($originDestinationOption);
    }
    /**
     * Get OriginDestinationOption value
     * @return \Sabre\BargainFinderMax\Structs\OriginDestinationOption[]|null
     */
    public function getOriginDestinationOption()
    {
        return $this->OriginDestinationOption;
    }
    /**
     * Set OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \Sabre\BargainFinderMax\Structs\OriginDestinationOption[] $originDestinationOption
     * @return \Sabre\BargainFinderMax\Structs\OriginDestinationOptions
     */
    public function setOriginDestinationOption(array $originDestinationOption = array())
    {
        $this->OriginDestinationOption = $originDestinationOption;
        return $this;
    }
    /**
     * Add item to OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \Sabre\BargainFinderMax\Structs\OriginDestinationOption $item
     * @return \Sabre\BargainFinderMax\Structs\OriginDestinationOptions
     */
    public function addToOriginDestinationOption(\Sabre\BargainFinderMax\Structs\OriginDestinationOption $item)
    {
        $this->OriginDestinationOption[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\OriginDestinationOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
