<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromoRedemption Structs
 * Meta informations extracted from the WSDL
 * - documentation: Populated if "Coupon Redemption" rule has been hit. This had been developed for Travelocity but never used.
 * @subpackage Structs
 */
class PromoRedemption extends AbstractStructBase
{
    /**
     * The PromoID
     * @var string
     */
    public $PromoID;
    /**
     * The Eligible
     * @var bool
     */
    public $Eligible;
    /**
     * The ContentID
     * @var string
     */
    public $ContentID;
    /**
     * Constructor method for PromoRedemption
     * @uses PromoRedemption::setPromoID()
     * @uses PromoRedemption::setEligible()
     * @uses PromoRedemption::setContentID()
     * @param string $promoID
     * @param bool $eligible
     * @param string $contentID
     */
    public function __construct($promoID = null, $eligible = null, $contentID = null)
    {
        $this
            ->setPromoID($promoID)
            ->setEligible($eligible)
            ->setContentID($contentID);
    }
    /**
     * Get PromoID value
     * @return string|null
     */
    public function getPromoID()
    {
        return $this->PromoID;
    }
    /**
     * Set PromoID value
     * @param string $promoID
     * @return \Sabre\BargainFinderMax\Structs\PromoRedemption
     */
    public function setPromoID($promoID = null)
    {
        $this->PromoID = $promoID;
        return $this;
    }
    /**
     * Get Eligible value
     * @return bool|null
     */
    public function getEligible()
    {
        return $this->Eligible;
    }
    /**
     * Set Eligible value
     * @param bool $eligible
     * @return \Sabre\BargainFinderMax\Structs\PromoRedemption
     */
    public function setEligible($eligible = null)
    {
        $this->Eligible = $eligible;
        return $this;
    }
    /**
     * Get ContentID value
     * @return string|null
     */
    public function getContentID()
    {
        return $this->ContentID;
    }
    /**
     * Set ContentID value
     * @param string $contentID
     * @return \Sabre\BargainFinderMax\Structs\PromoRedemption
     */
    public function setContentID($contentID = null)
    {
        $this->ContentID = $contentID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\PromoRedemption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
