<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SideTrip Structs
 * Meta informations extracted from the WSDL
 * - documentation: Side Trip | Side trip information
 * - minOccurs: 0
 * - type: SideTripType
 * @subpackage Structs
 */
class SideTrip extends AbstractStructBase
{
    /**
     * The Begin
     * Meta informations extracted from the WSDL
     * - default: 0
     * - documentation: Side Trip Begin
     * - use: optional
     * @var bool
     */
    public $Begin;
    /**
     * The End
     * Meta informations extracted from the WSDL
     * - default: 0
     * - documentation: Side Trip End
     * - use: optional
     * @var bool
     */
    public $End;
    /**
     * Constructor method for SideTrip
     * @uses SideTrip::setBegin()
     * @uses SideTrip::setEnd()
     * @param bool $begin
     * @param bool $end
     */
    public function __construct($begin = false, $end = false)
    {
        $this
            ->setBegin($begin)
            ->setEnd($end);
    }
    /**
     * Get Begin value
     * @return bool|null
     */
    public function getBegin()
    {
        return $this->Begin;
    }
    /**
     * Set Begin value
     * @param bool $begin
     * @return \Sabre\BargainFinderMax\Structs\SideTrip
     */
    public function setBegin($begin = false)
    {
        $this->Begin = $begin;
        return $this;
    }
    /**
     * Get End value
     * @return bool|null
     */
    public function getEnd()
    {
        return $this->End;
    }
    /**
     * Set End value
     * @param bool $end
     * @return \Sabre\BargainFinderMax\Structs\SideTrip
     */
    public function setEnd($end = false)
    {
        $this->End = $end;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\SideTrip
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
