<?php

namespace Sabre\BargainFinderMax\Structs;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StayRestrictionsType Structs
 * Meta informations extracted from the WSDL
 * - documentation: Type defining Min and Max Stay Restrictions.
 * @subpackage Structs
 */
class StayRestrictionsType extends AbstractStructBase
{
    /**
     * The MinimumStay
     * @var \Sabre\BargainFinderMax\Structs\MinimumStay
     */
    public $MinimumStay;
    /**
     * The MaximumStay
     * @var \Sabre\BargainFinderMax\Structs\MaximumStay
     */
    public $MaximumStay;
    /**
     * The StayRestrictionsInd
     * Meta informations extracted from the WSDL
     * - documentation: True indicates that Stay Restrictions exist.
     * - use: optional
     * @var bool
     */
    public $StayRestrictionsInd;
    /**
     * Constructor method for StayRestrictionsType
     * @uses StayRestrictionsType::setMinimumStay()
     * @uses StayRestrictionsType::setMaximumStay()
     * @uses StayRestrictionsType::setStayRestrictionsInd()
     * @param \Sabre\BargainFinderMax\Structs\MinimumStay $minimumStay
     * @param \Sabre\BargainFinderMax\Structs\MaximumStay $maximumStay
     * @param bool $stayRestrictionsInd
     */
    public function __construct(\Sabre\BargainFinderMax\Structs\MinimumStay $minimumStay = null, \Sabre\BargainFinderMax\Structs\MaximumStay $maximumStay = null, $stayRestrictionsInd = null)
    {
        $this
            ->setMinimumStay($minimumStay)
            ->setMaximumStay($maximumStay)
            ->setStayRestrictionsInd($stayRestrictionsInd);
    }
    /**
     * Get MinimumStay value
     * @return \Sabre\BargainFinderMax\Structs\MinimumStay|null
     */
    public function getMinimumStay()
    {
        return $this->MinimumStay;
    }
    /**
     * Set MinimumStay value
     * @param \Sabre\BargainFinderMax\Structs\MinimumStay $minimumStay
     * @return \Sabre\BargainFinderMax\Structs\StayRestrictionsType
     */
    public function setMinimumStay(\Sabre\BargainFinderMax\Structs\MinimumStay $minimumStay = null)
    {
        $this->MinimumStay = $minimumStay;
        return $this;
    }
    /**
     * Get MaximumStay value
     * @return \Sabre\BargainFinderMax\Structs\MaximumStay|null
     */
    public function getMaximumStay()
    {
        return $this->MaximumStay;
    }
    /**
     * Set MaximumStay value
     * @param \Sabre\BargainFinderMax\Structs\MaximumStay $maximumStay
     * @return \Sabre\BargainFinderMax\Structs\StayRestrictionsType
     */
    public function setMaximumStay(\Sabre\BargainFinderMax\Structs\MaximumStay $maximumStay = null)
    {
        $this->MaximumStay = $maximumStay;
        return $this;
    }
    /**
     * Get StayRestrictionsInd value
     * @return bool|null
     */
    public function getStayRestrictionsInd()
    {
        return $this->StayRestrictionsInd;
    }
    /**
     * Set StayRestrictionsInd value
     * @param bool $stayRestrictionsInd
     * @return \Sabre\BargainFinderMax\Structs\StayRestrictionsType
     */
    public function setStayRestrictionsInd($stayRestrictionsInd = null)
    {
        $this->StayRestrictionsInd = $stayRestrictionsInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sabre\BargainFinderMax\Structs\StayRestrictionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
